unit CrackForm_Unit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Gauges, ShellAPI, CREEQ;

type
  TCrackForm = class(TForm)
    Panel1: TPanel;
    StepGauge: TGauge;
    Label1: TLabel;
    StepLabel: TLabel;
    WaitTimer: TTimer;
    procedure WaitTimerTimer(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  CrackForm: TCrackForm;

implementation

uses Unit_Mainform;

{$R *.dfm}

procedure TCrackForm.WaitTimerTimer(Sender: TObject);
var RCFile, ChangesUnit, BatchFile, DPRFile: TextFile;
    Item, Cycle: Integer;
    Nr: Cardinal;
begin
  Nr := 0;
  StepLabel.Caption := 'Preparing compiling process.';
  WaitTimer.Enabled := FALSE;
  StepGauge.Progress := 0;
  AssignFile(ChangesUnit, HomeDir + 'source\ChangesUnit.pas');
  ReWrite(ChangesUnit);
  WriteLn(ChangesUnit,'unit ChangesUnit;');
  WriteLn(ChangesUnit,'interface');
  WriteLn(ChangesUnit,'const');
  WriteLn(ChangesUnit,'      CrackCaption = ''' + Mainform.CaptionEdit.Text + ''';');
  WriteLn(ChangesUnit,'      InfoText = ''' + Mainform.InfoTextEdit.Text + ''';');
  if Length(MainForm.LogoEdit.Text) > 0 then WriteLn(ChangesUnit,'      LogoExists = TRUE;')
    else WriteLn(ChangesUnit,'      LogoExists = FALSE;');
  for Item := 1 to 3 do
  begin
    StepGauge.Progress := StepGauge.Progress + 1;
    Delay(500);
    StepLabel.Caption := 'Comparing original and cracked file. (' + IntToStr(Item) + ')';
    if Item <= Mainform.OriginalListBox.Items.Count then
    begin
      if Item = 1 then
      begin
        Nr := GetDiff(Mainform.DirectoryEdit.Text + Mainform.OriginalListBox.Items[Item-1],Mainform.CrackedListBox.Items[Item-1],HomeDir + 'compile\file' + IntToStr(Item) + '.diff');
        if Nr = 0 then
        begin
          MessageBox(0, PChar('No differences found in file <' + Mainform.CrackedListBox.Items[Item-1] + '>'), 'ERROR', MB_OK or MB_ICONERROR);
          CrackForm.Close;
          Exit;
        end;
      end;
      WriteLn(ChangesUnit,'      FileName' + IntToStr(Item) + ' = ''' + Mainform.OriginalListBox.Items[Item-1] + ''';');
      WriteLn(ChangesUnit,'      CRC' + IntToStr(Item) + ' = ''' + GetCRC32(Mainform.DirectoryEdit.Text + Mainform.OriginalListBox.Items[Item-1]) + ''';');
      WriteLn(ChangesUnit,'      Nr' + IntToStr(Item) + ' = ' + IntToStr(Nr) + ';');
      if (DateiSize(Mainform.DirectoryEdit.Text + Mainform.OriginalListBox.Items[Item-1])) > (DateiSize(Mainform.CrackedListBox.Items[Item-1])) then
        WriteLn(ChangesUnit,'      EOF' + IntToStr(Item) + ' = TRUE;')
      else WriteLn(ChangesUnit,'      EOF' + IntToStr(Item) + ' = FALSE;');
    end else
    begin
      WriteLn(ChangesUnit,'      FileName' + IntToStr(Item) + ' = '''';');
      WriteLn(ChangesUnit,'      CRC' + IntToStr(Item) + ' = '''';');
      WriteLn(ChangesUnit,'      Nr' + IntToStr(Item) + ' = 0;');
      WriteLn(ChangesUnit,'      EOF' + IntToStr(Item) + ' = FALSE;');
    end;
  end;
  WriteLn(ChangesUnit,'implementation');
  WriteLn(ChangesUnit,'end.');
  CloseFile(ChangesUnit);
  StepGauge.Progress := StepGauge.Progress + 1;
  StepLabel.Caption := 'Compiling Resources.';
  AssignFile(RCFile, HomeDir + 'compile\Crack.rc');
  ReWrite(RCFile);
  if Length(Mainform.IconEdit.Text) > 0 then
    WriteLn(RCFile, 'MAINICON Icon "' + Mainform.IconEdit.Text + '"');
  if Length(Mainform.LogoEdit.Text) > 0 then
    WriteLn(RCFile, 'LOGO Bitmap "' + Mainform.LogoEdit.Text + '"');
  CloseFile(RCFile);
  AssignFile(BatchFile, HomeDir + 'compile\compile.bat');
  ReWrite(BatchFile);
  WriteLn(BatchFile, 'brcc32.exe Crack.rc');
  WriteLn(BatchFile, 'move Crack.RES ..\source\');
  CloseFile(BatchFile);
  SetCurrentDir(HomeDir + 'compile\');
  ShellExecute(handle, 'open', PChar(HomeDir + 'compile\compile.bat'), nil, nil, SW_HIDE);
  SetCurrentDir(HomeDir);
  Cycle := 0;
  while (Cycle < 60) and not FileExists(HomeDir + 'source\Crack.RES') do
  begin
    Delay(500);
    Inc(Cycle);
  end;
  if Cycle >= 60 then
  begin
    MessageBox(0, 'Error while compiling resources, operation timed out.', 'FATAL ERROR', MB_OK or MB_ICONERROR);
    Exit;
  end;
  for Item := 1 to MainForm.OriginalListBox.Items.Count do
  begin
    AssignFile(RCFile, HomeDir + 'compile\file' + IntToStr(Item) + '.rc');
    ReWrite(RCFile);
    WriteLn(RCFile, '10' + IntToStr(Item) + ' RCDATA "file' + IntToStr(Item) + '.diff"');
    CloseFile(RCFile);
    ReWrite(BatchFile);
    WriteLn(BatchFile, 'brcc32.exe file' + IntToStr(Item) + '.rc');
    WriteLn(BatchFile, 'move file' + IntToStr(Item) + '.RES ..\source\');
    CloseFile(BatchFile);
    SetCurrentDir(HomeDir + 'compile\');
    ShellExecute(handle, 'open', PChar(HomeDir + 'compile\compile.bat'), nil, nil, SW_HIDE);
    SetCurrentDir(HomeDir);
    Cycle := 0;
    while (Cycle < 60) and not FileExists(HomeDir + 'source\file' + IntToStr(Item) + '.RES') do
    begin
      Delay(500);
      Inc(Cycle);
    end;
    if Cycle >= 60 then
    begin
      MessageBox(0, 'Error while compiling resources, operation timed out.', 'FATAL ERROR', MB_OK or MB_ICONERROR);
      Exit;
    end;
  end;
  StepGauge.Progress := StepGauge.Progress + 1;
  StepLabel.Caption := 'Compiling ChangesUnit.';
  ReWrite(BatchFile);
  WriteLn(BatchFile, 'dcc32.exe "' + HomeDir + 'source\ChangesUnit.pas"');
  CloseFile(BatchFile);
  SetCurrentDir(HomeDir + 'compile\');
  ShellExecute(handle, 'open', PChar(HomeDir + 'compile\compile.bat'), nil, nil, SW_HIDE);
  SetCurrentDir(HomeDir);
  Cycle := 0;
  while (Cycle < 60) and not FileExists(HomeDir + 'source\ChangesUnit.dcu') do
  begin
    Delay(500);
    Inc(Cycle);
  end;
  if Cycle >= 60 then
  begin
    MessageBox(0, 'Error while compiling ChangesUnit, operation timed out.', 'FATAL ERROR', MB_OK or MB_ICONERROR);
    Exit;
  end;
  StepGauge.Progress := StepGauge.Progress + 1;
  StepLabel.Caption := 'Compiling MainForm_Unit.';
  ReWrite(BatchFile);
  WriteLn(BatchFile, 'dcc32.exe "' + HomeDir + 'source\MainForm_Unit.pas"');
  CloseFile(BatchFile);
  SetCurrentDir(HomeDir + 'compile\');
  ShellExecute(handle, 'open', PChar(HomeDir + 'compile\compile.bat'), nil, nil, SW_HIDE);
  SetCurrentDir(HomeDir);
  Cycle := 0;
  while (Cycle < 60) and not FileExists(HomeDir + 'source\MainForm_Unit.dcu') do
  begin
    Delay(500);
    Inc(Cycle);
  end;
  if Cycle >= 60 then
  begin
    MessageBox(0, 'Error while compiling MainForm_Unit, operation timed out.', 'FATAL ERROR', MB_OK or MB_ICONERROR);
    Exit;
  end;
  StepGauge.Progress := StepGauge.Progress + 1;
  StepLabel.Caption := 'Compiling Crack.';
  AssignFile(DPRFile, HomeDir + 'source\Crack.dpr');
  ReWrite(DPRFile);
  WriteLn(DPRFile, 'program Crack;');
  WriteLn(DPRFile, 'uses');
  WriteLn(DPRFile, '  Forms,');
  WriteLn(DPRFile, '  MainForm_Unit in ''MainForm_Unit.pas'' {MainForm},');
  WriteLn(DPRFile, '  ChangesUnit in ''ChangesUnit.pas'';');
  WriteLn(DPRFile, '{$R *.res}');
  for Item := 1 to MainForm.OriginalListBox.Items.Count do
    WriteLn(DPRFile, '{$R file' + IntToStr(Item) + '.res}');
  WriteLn(DPRFile, 'begin');
  WriteLn(DPRFile, '  Application.Initialize;');
  WriteLn(DPRFile, '  Application.HelpFile := '''';');
  WriteLn(DPRFile, '  Application.Title := ''Crack'';');
  WriteLn(DPRFile, '  Application.CreateForm(TMainForm, MainForm);');
  WriteLn(DPRFile, '  Application.Run;');
  WriteLn(DPRFile, 'end.');
  CloseFile(DPRFile);
  ReWrite(BatchFile);
  WriteLn(BatchFile, 'dcc32.exe "' + HomeDir + 'source\Crack.dpr"');
  CloseFile(BatchFile);
  SetCurrentDir(HomeDir + 'compile\');
  ShellExecute(handle, 'open', PChar(HomeDir + 'compile\compile.bat'), nil, nil, SW_HIDE);
  SetCurrentDir(HomeDir);
  Cycle := 0;
  while (Cycle < 60) and not FileExists(HomeDir + 'source\Crack.exe') do
  begin
    Delay(500);
    Inc(Cycle);
  end;
  if Cycle >= 60 then
  begin
    MessageBox(0, 'Error while compiling Crack, operation timed out.', 'FATAL ERROR', MB_OK or MB_ICONERROR);
    Exit;
  end;
  StepGauge.Progress := StepGauge.Progress + 1;
  StepLabel.Caption := 'Finished.';
  CopyFile(PChar(HomeDir + 'source\Crack.exe'), PChar(HomeDir + 'Crack.exe'), FALSE);
  MessageBox(0, 'Crack created.', 'SUCCESS', MB_OK or MB_ICONINFORMATION);
  CrackForm.Close;
end;

procedure TCrackForm.FormShow(Sender: TObject);
begin
  WaitTimer.Enabled := TRUE;
end;

end.
