unit Unit_Mainform;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, CREEQ, StdCtrls, ExtCtrls, IdGlobal, ExtDlgs;

type
  TMainForm = class(TForm)
    Orgina: TLabel;
    Panel1: TPanel;
    OriginalFileEdit: TEdit;
    OriginalFileButton: TButton;
    OriginalFileOpenDialog: TOpenDialog;
    CrackedFileOpenDialog: TOpenDialog;
    Label1: TLabel;
    CrackedFileEdit: TEdit;
    CrackedFileButton: TButton;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    CaptionEdit: TEdit;
    CrackButton: TButton;
    Label3: TLabel;
    IconEdit: TEdit;
    IconBrowseButton: TButton;
    IconOpenDialog: TOpenDialog;
    Label4: TLabel;
    LogoEdit: TEdit;
    LogoBrowseButton: TButton;
    LogoOpenDialog: TOpenDialog;
    Label5: TLabel;
    InfoTextEdit: TEdit;
    Panel2: TPanel;
    OriginalListBox: TListBox;
    Label6: TLabel;
    CrackedListBox: TListBox;
    AddButton: TButton;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    DirectoryEdit: TEdit;
    HelpButton: TButton;
    DelButton: TButton;
    procedure OriginalFileButtonClick(Sender: TObject);
    procedure CrackedFileButtonClick(Sender: TObject);
    procedure CrackButtonClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure IconBrowseButtonClick(Sender: TObject);
    procedure LogoBrowseButtonClick(Sender: TObject);
    procedure AddButtonClick(Sender: TObject);
    procedure DirectoryEditExit(Sender: TObject);
    procedure OriginalFileEditChange(Sender: TObject);
    procedure CrackedFileEditChange(Sender: TObject);
    procedure HelpButtonClick(Sender: TObject);
    procedure DelButtonClick(Sender: TObject);
    procedure OriginalListBoxClick(Sender: TObject);
    procedure CrackedListBoxClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

procedure Delay(MSeconds : Longint);

var
  MainForm: TMainForm;
  HomeDir: String;

implementation

uses CrackForm_Unit;

{$R *.dfm}

procedure Delay(MSeconds : Longint);
var FTickCount: Longint;
Begin
  FTickCount := GetTickCount;
  Repeat
    Application.ProcessMessages;
  Until ((GetTickCount-FTickCount) >= MSeconds);
end;

procedure TMainForm.OriginalFileButtonClick(Sender: TObject);
begin
  OriginalFileOpenDialog.InitialDir := DirectoryEdit.Text;
  OriginalFileOpenDialog.Execute;
  OriginalFileEdit.Text := OriginalFileOpenDialog.FileName;
  if Length(DirectoryEdit.Text) = 0 then
    DirectoryEdit.Text := ExtractFilePath(OriginalFileEdit.Text); 
end;

procedure TMainForm.CrackedFileButtonClick(Sender: TObject);
begin
  CrackedFileOpenDialog.InitialDir := DirectoryEdit.Text;
  CrackedFileOpenDialog.Execute;
  CrackedFileEdit.Text := CrackedFileOpenDialog.FileName;
end;

procedure TMainForm.CrackButtonClick(Sender: TObject);
begin
  if not (OriginalListBox.Items.Count > 0) then
  begin
    MessageBox(0, 'You should first specify original-cracked-file-pairs.', 'ERROR', MB_OK or MB_ICONERROR);
    Exit;
  end;
  if (Length(IconEdit.Text) > 0) and not FileExists(IconEdit.Text) then
  begin
    MessageBox(0, 'Icon not found.', 'ERROR', MB_OK or MB_ICONERROR);
    Exit;
  end;
  if (Length(LogoEdit.Text) > 0) and not FileExists(LogoEdit.Text) then
  begin
    MessageBox(0, 'Logo not found.', 'ERROR', MB_OK or MB_ICONERROR);
    Exit;
  end;
  if not DirectoryExists(HomeDir + 'compile') then
  begin
    MessageBox(0, 'Compiler is missing.', 'ERROR', MB_OK or MB_ICONERROR);
    Exit;
  end;
  if not DirectoryExists(HomeDir + 'source') then
  begin
    MessageBox(0, 'Source code is missing.', 'ERROR', MB_OK or MB_ICONERROR);
    Exit;
  end;
  CrackButton.Enabled := FALSE;
  CrackForm.ShowModal;
  CrackButton.Enabled := TRUE;
end;

procedure TMainForm.FormShow(Sender: TObject);
var i: Integer;
begin
  HomeDir := GetCurrentDir + '\';
  if FileExists(HomeDir + 'compile\compile.bat') then DeleteFile(HomeDir + 'compile\compile.bat');
  if FileExists(HomeDir + 'compile\Crack.rc') then DeleteFile(HomeDir + 'compile\Crack.rc');
  for i := 1 to 3 do
  begin
    if FileExists(HomeDir + 'compile\file' + IntToStr(i) + '.diff') then DeleteFile(HomeDir + 'compile\file' + IntToStr(i) + '.diff');
    if FileExists(HomeDir + 'compile\file' + IntToStr(i) + '.rc') then DeleteFile(HomeDir + 'compile\file' + IntToStr(i) + '.rc');
    if FileExists(HomeDir + 'source\file' + IntToStr(i) + '.RES') then DeleteFile(HomeDir + 'source\file' + IntToStr(i) + '.RES');
  end;
  if FileExists(HomeDir + 'source\Crack.RES') then DeleteFile(HomeDir + 'source\Crack.RES');
  if FileExists(HomeDir + 'source\MainForm_Unit.dcu') then DeleteFile(HomeDir + 'source\MainForm_Unit.dcu');
  if FileExists(HomeDir + 'source\ChangesUnit.dcu') then DeleteFile(HomeDir + 'source\ChangesUnit.dcu');
  if FileExists(HomeDir + 'source\Crack.exe') then DeleteFile(HomeDir + 'source\Crack.exe');
  if FileExists(HomeDir + 'source\Crack.dpr') then DeleteFile(HomeDir + 'source\Crack.dpr');
  if FileExists(HomeDir + 'Crack.exe') then DeleteFile(HomeDir + 'Crack.exe');
end;

procedure TMainForm.IconBrowseButtonClick(Sender: TObject);
begin
  IconOpenDialog.Execute;
  IconEdit.Text := IconOpenDialog.FileName;
end;

procedure TMainForm.LogoBrowseButtonClick(Sender: TObject);
begin
  LogoOpenDialog.Execute;
  LogoEdit.Text := LogoOpenDialog.FileName;
end;

procedure TMainForm.AddButtonClick(Sender: TObject);
begin
  if OriginalListBox.Items.Count = 3 then
  begin
    MessageBox(0, 'You cannot add more files. Ask CREEQ to add more.', 'FATAL ERROR', MB_OK or MB_ICONERROR);
    Exit;
  end;
  if not DirectoryExists(DirectoryEdit.Text) then
  begin
    MessageBox(0, 'The directory does not exist.', 'ERROR', MB_OK or MB_ICONERROR);
    Exit;
  end;
  if not FileExists(OriginalFileEdit.Text) then
  begin
    MessageBox(0, 'The original file does not exist.', 'ERROR', MB_OK or MB_ICONERROR);
    Exit;
  end;
  if not FileExists(CrackedFileEdit.Text) then
  begin
    MessageBox(0, 'The cracked file does not exist.', 'ERROR', MB_OK or MB_ICONERROR);
    Exit;
  end;
  OriginalListBox.Items.Add(Copy(OriginalFileEdit.Text, Length(DirectoryEdit.Text)+1, Length(OriginalFileEdit.Text) - Length(DirectoryEdit.Text)));
  CrackedListBox.Items.Add(CrackedFileEdit.Text);
  OriginalFileEdit.Clear;
  CrackedFileEdit.Clear;
  OriginalFileOpenDialog.Filename := '';
  CrackedFileOpenDialog.Filename := '';
  DirectoryEdit.Enabled := FALSE;
end;

procedure TMainForm.DirectoryEditExit(Sender: TObject);
begin
  if (Length(DirectoryEdit.Text) > 0) and not (DirectoryEdit.Text[Length(DirectoryEdit.Text)] = '\') then
    DirectoryEdit.Text := DirectoryEdit.Text + '\';
end;

procedure TMainForm.OriginalFileEditChange(Sender: TObject);
begin
  if (Length(OriginalFileEdit.Text) > 0) and (Length(CrackedFileEdit.Text) > 0) then
  begin
    AddButton.Enabled := TRUE;
  end else
  begin
    AddButton.Enabled := FALSE;
  end;
end;

procedure TMainForm.CrackedFileEditChange(Sender: TObject);
begin
  if (Length(OriginalFileEdit.Text) > 0) and (Length(CrackedFileEdit.Text) > 0) then
  begin
    AddButton.Enabled := TRUE;
  end else
  begin
    AddButton.Enabled := FALSE;
  end;
end;

procedure TMainForm.HelpButtonClick(Sender: TObject);
begin
  MessageBox(0, 'Ask CREEQ ...', 'Information', MB_OK or MB_ICONINFORMATION);
end;

procedure TMainForm.DelButtonClick(Sender: TObject);
begin
  OriginalListBox.Items.Delete(OriginalListBox.ItemIndex);
  CrackedListBox.Items.Delete(CrackedListBox.ItemIndex);
  if OriginalListBox.Items.Count = 0 then
    DirectoryEdit.Enabled := TRUE;
  DelButton.Enabled := FALSE;
end;

procedure TMainForm.OriginalListBoxClick(Sender: TObject);
begin
  CrackedListBox.ItemIndex := OriginalListBox.ItemIndex;
  DelButton.Enabled := TRUE;
end;

procedure TMainForm.CrackedListBoxClick(Sender: TObject);
begin
  OriginalListBox.ItemIndex := CrackedListBox.ItemIndex;
  DelButton.Enabled := TRUE;
end;

end.
